/*
 *
 * FxHedgeSim 20081012 for lack of a better name.
 *
 *   Inspired by oludotun's ideas posted in thread titled "Simple Trading
 * Method", on the fxfisherman.com forum.
 *
 */

#property copyright "FxHedgeSim - Copyright  2008 AUPaver"

#property indicator_chart_window
extern color PositiveColor =      Lime;
extern color NegativeColor =       Red;
extern int   PricePeriod   = PERIOD_D1;
extern int   PriceOffset   =         3;


string   Font          = "Lucida Console";
string   FXHSI_LS[][14];
datetime FXHSI_PT      = 0;
string   Columns[2][6] = {"Pos","Type","Sym","Price","Current","Gain",
                          "305", "260","200",  "135",     "70",  "20"};

void FxHedgeSim(  string   FxHedgeSimList[][14],
                  
                  datetime FxHedgeSimPriceTime,
                  
                  int      FxHedgeSimPricePeriod,
                  
                  int      FxHedgeSimPriceOffset  ){
                  
  string s[2][7] = {"AUDUSD",  //group 0 buy
                    "CADJPY",
                    "EURCHF",
                    "EURUSD",
                    "GBPJPY",
                    "USDCAD",
                    "USDJPY",
                          
                    "AUDJPY",  //group 1 sell
                    "CHFJPY",
                    "EURGBP",
                    "EURJPY",
                    "GBPCHF",
                    "GBPUSD",
                    "USDCHF"};
                          
  string   ls[5][14] = {"","","","","","","","","","","","","",""  ,
                        "","","","","","","","","","","","","",""  ,
                        "","","","","","","","","","","","","",""  ,
                        "","","","","","","","","","","","","",""  ,
                        "","","","","","","","","","","","","",""};
  double   pr[2][7]  = {0,0,0,0,0,0,0  ,  0,0,0,0,0,0,0};
  double   cp[2][7]  = {0,0,0,0,0,0,0  ,  0,0,0,0,0,0,0};
  datetime pt = 0;
  int    pg[2][7]  = {0,0,0,0,0,0,0  ,  0,0,0,0,0,0,0};
  int a, b, c, d, e, f, lastp;
  double p;
  string ts[][7], lasts;
  if( FxHedgeSimPriceTime!=0 && FxHedgeSimPriceTime == iTime(Symbol(),FxHedgeSimPricePeriod,FxHedgeSimPriceOffset) ){
    a=0;
  }else{
    c  = 0;
    while(1==1){
      for(a=0;a<=1;a++){
        for(b=0;b<=6;b++){
          if( iOpen(s[a][b],FxHedgeSimPricePeriod,FxHedgeSimPriceOffset)==0 ){
            c = 1;
          }
        }
      }
      if(c==0) break;
      c = 0;
    }
    for(a=0;a<=1;a++){
      for(b=0;b<=6;b++){
        pr[a][b] = iOpen(s[a][b],FxHedgeSimPricePeriod,FxHedgeSimPriceOffset);
      }
    }
    pt = iTime(Symbol(),FxHedgeSimPricePeriod,FxHedgeSimPriceOffset);
  }
  for(a=0;a<=1;a++){
    for(b=0;b<=6;b++){
      p        = MarketInfo(s[a][b],MODE_POINT);
      cp[a][b] = MarketInfo(s[a][b],MODE_BID);
      if(cp[a][b]>pr[a][b]){
        c = (cp[a][b]-pr[a][b])/p;
        if(a==0){
          pg[a][b] = c;
        }else{
          pg[a][b] = -(c);
        }
      }else if(cp[a][b]<pr[a][b]){
        c = (pr[a][b]-cp[a][b])/p;
        if(a==0){
          pg[a][b] = -(c);
        }else{
          pg[a][b] = c;
        }
      }
    }
  }
  ArrayCopy(ts,s);
  a    = 0;
  d    = NULL;
  e    = NULL;
  lastp = NULL;
  lasts = "";
  while(a<=13){
    for(b=0;b<=1;b++){
      for(c=0;c<=6;c++){
        if(lasts==""&&ts[b][c]!=""){
          lasts = ts[b][c];
          lastp = pg[b][c];
        }
        if(ts[b][c]!=""){
          if(pg[b][c]>=lastp||lastp==NULL){
            lasts = ts[b][c];
            lastp = pg[b][c];
            d = b;
            e = c;
          }
        }
      }
    }
    if(d==0){
      ls[0][a] = "Buy";
    }else{
      ls[0][a] = "Sell";
    }
    ls[1][a] = lasts;
    for(f=9;f>=0;f--){
      if(StringGetChar(""+pr[d][e],f)!='0'){
        ls[2][a] = StringSubstr(""+pr[d][e],0,f+1);
        break;
      }
    }
    for(f=9;f>=0;f--){
      if(StringGetChar(""+cp[d][e],f)!='0'){
        ls[3][a] = StringSubstr(""+cp[d][e],0,f+1);
        break;
      }
    }
    ls[4][a] = lastp;
    ts[d][e] =    "";
    lasts    =    "";
    lastp    =  NULL;
    a++;
  }
  ArrayCopy(FxHedgeSimList, ls);
  FxHedgeSimPriceTime = pt;
}


void CreateListObjects(){
  int a, b, ypos;
  ObjectCreate("FxHedgeSim", OBJ_LABEL, 0, 0, 0);
  ObjectSetText("FxHedgeSim", "FxHedgeSim  ", 12, Font, PositiveColor);
  ObjectSet("FxHedgeSim", OBJPROP_CORNER, 1);
  ObjectSet("FxHedgeSim", OBJPROP_XDISTANCE, 210);
  ObjectSet("FxHedgeSim", OBJPROP_YDISTANCE, 10);
  
  for(a=0;a<=5;a++){
    ObjectCreate(Columns[0][a], OBJ_LABEL, 0, 0, 0);
    ObjectSetText(Columns[0][a], Columns[0][a], 10, Font, PositiveColor);
    ObjectSet(Columns[0][a], OBJPROP_CORNER, 1);
    ObjectSet(Columns[0][a], OBJPROP_XDISTANCE, StrToInteger(Columns[1][a]));
    ObjectSet(Columns[0][a], OBJPROP_YDISTANCE, 40);
    
    ypos = 60;
    for(b=0;b<=13;b++){
      ObjectCreate(Columns[0][a]+"_"+b, OBJ_LABEL, 0, 0, 0);
      ObjectSetText(Columns[0][a]+"_"+b, ""+(b+1), 8, Font, PositiveColor);
      ObjectSet(Columns[0][a]+"_"+b, OBJPROP_CORNER, 1);
      ObjectSet(Columns[0][a]+"_"+b, OBJPROP_XDISTANCE, StrToInteger(Columns[1][a]));
      ObjectSet(Columns[0][a]+"_"+b, OBJPROP_YDISTANCE, ypos);
      ypos += 15;
    }
  }
}

void DeleteListObjects(){
  int a, b;
  ObjectDelete("FxHedgeSim");
  for(a=0;a<=5;a++){
    ObjectDelete(Columns[0][a]);
    for(b=0;b<=13;b++) ObjectDelete(Columns[0][a]+"_"+b);
  }
}

void UpdateListObjects(){
  color cc;
  int a, b;
  FxHedgeSim(FXHSI_LS, FXHSI_PT, PricePeriod, PriceOffset);
  for(a=0;a<=13;a++){
    cc = PositiveColor;
    if(StrToInteger(FXHSI_LS[4][a])<0)
      cc = NegativeColor;
    ObjectSetText(Columns[0][0]+"_"+a,       ""+(a+1), 8, Font, cc);
    ObjectSetText(Columns[0][1]+"_"+a, FXHSI_LS[0][a], 8, Font, cc);
    ObjectSetText(Columns[0][2]+"_"+a, FXHSI_LS[1][a], 8, Font, cc);
    ObjectSetText(Columns[0][3]+"_"+a, FXHSI_LS[2][a], 8, Font, cc);
    ObjectSetText(Columns[0][4]+"_"+a, FXHSI_LS[3][a], 8, Font, cc);
    ObjectSetText(Columns[0][5]+"_"+a, FXHSI_LS[4][a], 8, Font, cc);
  }
}

int init(){
  CreateListObjects();
  UpdateListObjects();
  return(0);
}

int start(){
  UpdateListObjects();
  return(0);
}

int deinit(){
  DeleteListObjects();
  return(0);
}

